/**
 *
 *
  _____                      _              _ _ _     _   _     _        __ _ _
 |  __ \                    | |            | (_) |   | | | |   (_)      / _(_) |
 | |  | | ___    _ __   ___ | |_    ___  __| |_| |_  | |_| |__  _ ___  | |_ _| | ___
 | |  | |/ _ \  | '_ \ / _ \| __|  / _ \/ _` | | __| | __| '_ \| / __| |  _| | |/ _ \
 | |__| | (_) | | | | | (_) | |_  |  __/ (_| | | |_  | |_| | | | \__ \ | | | | |  __/
 |_____/ \___/  |_| |_|\___/ \__|  \___|\__,_|_|\__|  \__|_| |_|_|___/ |_| |_|_|\___|

 * DO NOT EDIT THIS FILE!!
 *
 *  FOR CUSTOMIZE perfilBaseService PLEASE EDIT ../perfil.service.ts
 *
 *  -- THIS FILE WILL BE OVERWRITTEN ON THE NEXT SKAFFOLDER'S CODE GENERATION --
 *
 */
 // DEPENDENCIES
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { map } from 'rxjs/operators';
import { HttpClient } from '@angular/common/http';

// CONFIG
import { environment } from '../../../environments/environment';

// MODEL
import { Perfil } from '../../domain/gifloadmin_db/perfil';

/**
 * THIS SERVICE MAKE HTTP REQUEST TO SERVER, FOR CUSTOMIZE IT EDIT ../Perfil.service.ts
 */

/*
 * SCHEMA DB Perfil
 *
	{
		activo: {
			type: 'String'
		},
		nombre: {
			type: 'String'
		},
		//RELATIONS
		//EXTERNAL RELATIONS
		usuarioPerfiles: {
			type: Schema.ObjectId,
			ref : "Perfil"
		},
	}
 *
 */

export class PerfilBaseService {

    contextUrl: string = environment.endpoint + '/perfil';
    constructor(
        protected http: HttpClient
        ) { }

    // CRUD METHODS

    /**
    * PerfilService.create
    *   @description CRUD ACTION create
    *   @param Perfil obj Object to insert
    *
    */
    create(item: Perfil): Observable<Perfil> {
        return this.http
            .post<Perfil>(this.contextUrl, item)
            .pipe(map(data => data));
    }

    /**
    * PerfilService.delete
    *   @description CRUD ACTION delete
    *   @param ObjectId id Id Perfil
    *
    */
    remove(id: string): Observable<void> {
        return this.http
            .delete<void>(this.contextUrl + '/' + id)
            .pipe(map(data => data));
    }

    /**
    * PerfilService.get
    *   @description CRUD ACTION get
    *   @param ObjectId id Id Perfil
    *   @returns Perfil
    *
    */
    get(id: string): Observable<Perfil> {
        return this.http
            .get<Perfil>(this.contextUrl + '/' + id)
            .pipe(map(data => data));
    }

    /**
    * PerfilService.list
    *   @description CRUD ACTION list
    *   @returns ARRAY OF Perfil
    *
    */
    list(): Observable<Perfil[]> {
        return this.http
            .get<Perfil[]>(this.contextUrl)
            .pipe(map(data => data));
    }

    /**
    * PerfilService.update
    *   @description CRUD ACTION update
    *   @param ObjectId id Id Perfil
    *   @returns Perfil
    *
    */
    update(item: Perfil): Observable<Perfil> {
        return this.http
            .post<Perfil>(this.contextUrl + '/' + item.id, item)
            .pipe(map(data => data));
    }


    // Custom APIs

}
